// cxx-examples/src/autotags.cpp - class definitions for ASN.1 module World-Schema
//
//   This file was generated by esnacc on Wed Mar  1 14:11:44 2017

//   NOTE: this is a machine generated file--editing not recommended


#include "cxx-examples/src/autotags.h"

#ifndef NO_NAMESPACE
namespace SNACC {
#endif
//------------------------------------------------------------------------------
// value defs


//------------------------------------------------------------------------------
// class member definitions:

HumanChoice::Biblical & 
HumanChoice::Biblical::operator =(const Biblical &that)
{
	m_len = that.m_len;
	delete[] m_bytes;
	m_bytes = new unsigned char[m_len];
	memcpy(m_bytes, that.m_bytes, m_len);
	return *this;
}

const ValueRange*  
HumanChoice::Biblical::ValueRanges(int &sizeVRList) const
{
		static const ValueRange biblical_ValueRangeList[] = 
			{{ 1, 1000, 1 }};

		sizeVRList = 1;
		return &biblical_ValueRangeList[0];
}

HumanChoice::Modern & 
HumanChoice::Modern::operator =(const Modern &that)
{
	m_len = that.m_len;
	delete[] m_bytes;
	m_bytes = new unsigned char[m_len];
	memcpy(m_bytes, that.m_bytes, m_len);
	return *this;
}

const ValueRange*  
HumanChoice::Modern::ValueRanges(int &sizeVRList) const
{
		static const ValueRange modern_ValueRangeList[] = 
			{{ 1, 100, 1 }};

		sizeVRList = 1;
		return &modern_ValueRangeList[0];
}

HumanChoice::HumanChoice(const HumanChoice &that)
{
   Init();
   *this = that;
}
void HumanChoice::Init(void)
{
   // initialize choice to no choiceId to first choice and set pointer to NULL
  choiceId = biblicalCid;
  biblical = NULL;
}


int HumanChoice::checkConstraints(ConstraintFailList* pConstraintFails) const
{
	if (biblical != NULL)
		biblical->checkConstraints(pConstraintFails);

	if (modern != NULL)
		modern->checkConstraints(pConstraintFails);

	return 0;
}


void HumanChoice::Clear()
{
  switch (choiceId)
  {
    case biblicalCid:
      delete biblical;
      biblical = NULL;
      break;
    case modernCid:
      delete modern;
      modern = NULL;
      break;
  } // end of switch
} // end of Clear()

AsnType *HumanChoice::Clone() const
{
  return new HumanChoice(*this);
}

HumanChoice &HumanChoice::operator = (const HumanChoice &that)
{
  if (this != &that)
  {
    Clear();
    // Check first type in choice to determine if choice is empty
    if (that.biblical != NULL)
    {
       switch (choiceId = that.choiceId)
       {
         case biblicalCid:
           biblical = new Biblical(*that.biblical);
           break;
         case modernCid:
           modern = new Modern(*that.modern);
           break;
       }// end of switch
     }// end of if
  }

  return *this;
}

AsnLen
HumanChoice::BEncContent (AsnBuf &_b) const
{
    FUNC("HumanChoice::BEncContent (AsnBuf &_b)");
  AsnLen l=0;
  switch (choiceId)
  {
    case biblicalCid:
      l = biblical->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, CNTX, PRIM, 0);
      break;

    case modernCid:
      l = modern->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, CNTX, PRIM, 1);
      break;

      default:
         throw EXCEPT("Choice is empty", ENCODE_ERROR);
  } // end switch
  return l;
} // HumanChoice::BEncContent


void HumanChoice::BDecContent (const AsnBuf &_b, AsnTag tag, AsnLen elmtLen0, AsnLen &bytesDecoded /*, s env*/)
{
   FUNC("HumanChoice::BDecContent()");
   Clear();
  switch (tag)
  {
    case MAKE_TAG_ID (CNTX, PRIM, 0):
      choiceId = biblicalCid;
        biblical = new Biblical;
        biblical->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (CNTX, PRIM, 1):
      choiceId = modernCid;
        modern = new Modern;
        modern->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    default:
    {        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
      break;
    }
  } // end switch
} // HumanChoice::BDecContent


AsnLen HumanChoice::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    return l;
}

void HumanChoice::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    AsnLen elmtLen = 0;
    AsnTag tag;

    /*  CHOICEs are a special case - grab identifying tag */
    /*  this allows easier handling of nested CHOICEs */
    tag = BDecTag (_b, bytesDecoded);
    elmtLen = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen, bytesDecoded);
}

void HumanChoice::Print(std::ostream& os, unsigned short indent) const
{
	switch (choiceId)
	{
	case biblicalCid:
		os << "biblical ";
		if (biblical)
			biblical->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case modernCid:
		os << "modern ";
		if (modern)
			modern->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	} // end of switch
} // end of HumanChoice::Print()

void HumanChoice::PrintXML (std::ostream &os, const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
        os << " typeName=\"HumanChoice\" type=\"CHOICE\">";
  }
  else
        os << "<HumanChoice type=\"CHOICE\">";
  switch (choiceId)
  {
    case biblicalCid:
      if (biblical)
        biblical->PrintXML(os,"biblical");
      else
      {
        os << "<biblical -- void3 -- /biblical>" << std::endl;
      }
      break;

    case modernCid:
      if (modern)
        modern->PrintXML(os,"modern");
      else
      {
        os << "<modern -- void3 -- /modern>" << std::endl;
      }
      break;

  } // end of switch
  if (lpszTitle)
     os << "</" << lpszTitle << ">";
  else
        os << "</HumanChoice>";
} // HumanChoice::PrintXML

void Human::Init(void)
{
  first_words = new UTF8String;
  age = NULL;
}


int Human::checkConstraints(ConstraintFailList* pConstraintFails) const{
	name.checkConstraints(pConstraintFails);

	if (first_words != NULL)
		first_words->checkConstraints(pConstraintFails);

	if (age != NULL)
		age->checkConstraints(pConstraintFails);

	return 0;
}


void Human::Clear()
{
  if(first_words)
    delete first_words;
  first_words = NULL;
  if(age)
    delete age;
  age = NULL;
}

Human::Human(const Human &that)
{
   Init();
   *this = that;
}
AsnType *Human::Clone() const
{
  return new Human(*this);
}

Human &Human::operator = (const Human &that)
{
  if (this != &that)
  {
    Clear();
    name = that.name;
    if (that.first_words)
    {
      if (!first_words)
        first_words = new UTF8String;
      *first_words = *that.first_words;
    }
    else
    {
      delete first_words;
      first_words = NULL;
    }
    if (that.age)
    {
      if (!age)
        age = new HumanChoice;
      *age = *that.age;
    }
    else
    {
      delete age;
      age = NULL;
    }
  }

  return *this;
}

AsnLen
Human::BEncContent (AsnBuf &_b) const
{
  AsnLen totalLen = 0;
  AsnLen l=0;

    if (NOT_NULL(age)) {
    l = age->BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 2);
    totalLen += l;
  }

    if (first_words) {
    l = first_words->BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, CNTX, PRIM, 1);
    totalLen += l;
  }

    l = name.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, CNTX, PRIM, 0);
    totalLen += l;

  return totalLen;
} // Human::BEncContent


void Human::BDecContent (const AsnBuf &_b, AsnTag /*tag0*/, AsnLen elmtLen0, AsnLen &bytesDecoded)
{
  FUNC(" Human::BDecContent");
  Clear();
  AsnTag tag1 = AsnTag();
  AsnLen seqBytesDecoded = 0;
  AsnLen elmtLen1 = 0;
  AsnLen elmtLen2 = 0;
  tag1 = BDecTag (_b, seqBytesDecoded);

  if ((tag1 == MAKE_TAG_ID (CNTX, PRIM, 0))
    || (tag1 == MAKE_TAG_ID (CNTX, CONS, 0)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    name.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    if (seqBytesDecoded == elmtLen0)
    {
      bytesDecoded += seqBytesDecoded;
      return;
    }
    else
    {
      tag1 = BDecTag (_b, seqBytesDecoded);

      if ((elmtLen0 == INDEFINITE_LEN) && (tag1 == EOC_TAG_ID))
      {
        BDEC_2ND_EOC_OCTET (_b, seqBytesDecoded);
        bytesDecoded += seqBytesDecoded;
        return;
      }
    }
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (name)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (CNTX, PRIM, 1))
    || (tag1 == MAKE_TAG_ID (CNTX, CONS, 1)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
  // delete default value
  delete first_words;
  first_words = new UTF8String;
    first_words->BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    if (seqBytesDecoded == elmtLen0)
    {
      bytesDecoded += seqBytesDecoded;
      return;
    }
    else
    {
      tag1 = BDecTag (_b, seqBytesDecoded);

      if ((elmtLen0 == INDEFINITE_LEN) && (tag1 == EOC_TAG_ID))
      {
        BDEC_2ND_EOC_OCTET (_b, seqBytesDecoded);
        bytesDecoded += seqBytesDecoded;
        return;
      }
    }
  }

  if ((tag1 == MAKE_TAG_ID (CNTX, CONS, 2)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
    elmtLen2 = BDecLen (_b, seqBytesDecoded);
  age = new HumanChoice;
    age->BDecContent (_b, tag1, elmtLen2, seqBytesDecoded);
    if (elmtLen1 == INDEFINITE_LEN)
      BDecEoc (_b, seqBytesDecoded);

  }

  bytesDecoded += seqBytesDecoded;
  if (elmtLen0 == INDEFINITE_LEN)
  {
    BDecEoc (_b, bytesDecoded);
    return;
  }
  else if (seqBytesDecoded != elmtLen0)
  {
    throw EXCEPT("Length discrepancy on sequence", DECODE_ERROR);
  }
  else
    return;
} // Human::BDecContent

AsnLen Human::BEnc (AsnBuf &_b) const
{
  AsnLen l=0;
  l = BEncContent (_b);
  l += BEncConsLen (_b, l);
  l += BEncTag1 (_b, UNIV, CONS, SEQ_TAG_CODE);
  return l;
}

void Human::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
  FUNC(" Human::BDec");
  AsnTag tag;
  AsnLen elmtLen1;

  if ((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (UNIV, CONS, SEQ_TAG_CODE))
  {
    throw InvalidTagException(typeName(), tag, STACK_ENTRY);
  }
  elmtLen1 = BDecLen (_b, bytesDecoded);
  BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

void Human::Print(std::ostream& os, unsigned short indent) const
{
	os << "{ -- SEQUENCE --" << std::endl;
++indent;

	Indent(os, indent);
	os << "name ";
	name.Print(os, indent);
	os << ',' << std::endl;

	if (NOT_NULL (first_words))
	{
		os << ","<< std::endl;
		Indent(os, indent);
		os << "first-words ";
		first_words->Print(os, indent);
	}

	if (NOT_NULL (age))
	{
		os << ","<< std::endl;
		Indent(os, indent);
		os << "age ";
		age->Print(os, indent);
	}

	os << std::endl;
	--indent;
	Indent(os, indent);
	os << "}\n";
} // end of Human::Print()

void Human::PrintXML (std::ostream &os, 
                   const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
     if (typeName() && strlen(typeName()))
     {
        os << " typeName=\"" << typeName() << "\"";
     }
  }
  else
  {
     os << "<NONE";
  }
  if (typeName() && strlen(typeName()))
  {
     if (typeName() && strlen(typeName()))
     {
        os << "<" << typeName();
     }
  }
 os << " type=\"SEQUENCE\">" << std::endl;
    name.PrintXML(os, "name");

  if (NOT_NULL (first_words))
  {
    first_words->PrintXML(os, "first-words");
  }

  if (NOT_NULL (age))
  {
    age->PrintXML(os, "age");
  }

  if (lpszTitle)
  {
     os << "</" << lpszTitle << ">" << std::endl;
  }
  else
     if (typeName() && strlen(typeName()))
     {
        os << "</" << typeName() << ">" << std::endl;
     }
} // Human::PrintXML


#ifndef NO_NAMESPACE
} // namespace close
#endif
