// cxx-examples/src/rfc1157-snmp.cpp - class definitions for ASN.1 module RFC1157-SNMP
//
//   This file was generated by esnacc on Wed Mar  1 14:11:44 2017

//   NOTE: this is a machine generated file--editing not recommended


#include "cxx-examples/src/rfc1157-snmp.h"

#ifndef NO_NAMESPACE
namespace SNACC {
#endif
//------------------------------------------------------------------------------
// value defs


//------------------------------------------------------------------------------
// class member definitions:

void VarBind::Init(void)
{
}


int VarBind::checkConstraints(ConstraintFailList* pConstraintFails) const{
	name.checkConstraints(pConstraintFails);

	value.checkConstraints(pConstraintFails);

	return 0;
}


void VarBind::Clear()
{
  value.Clear();
}

VarBind::VarBind(const VarBind &that)
{
   Init();
   *this = that;
}
AsnType *VarBind::Clone() const
{
  return new VarBind(*this);
}

VarBind &VarBind::operator = (const VarBind &that)
{
  if (this != &that)
  {
    Clear();
    name = that.name;
    value = that.value;
  }

  return *this;
}

AsnLen
VarBind::BEncContent (AsnBuf &_b) const
{
  AsnLen totalLen = 0;
  AsnLen l=0;

    l = value.BEncContent (_b);
    totalLen += l;

    l = name.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, OID_TAG_CODE);
    totalLen += l;

  return totalLen;
} // VarBind::BEncContent


void VarBind::BDecContent (const AsnBuf &_b, AsnTag /*tag0*/, AsnLen elmtLen0, AsnLen &bytesDecoded)
{
  FUNC(" VarBind::BDecContent");
  Clear();
  AsnTag tag1 = AsnTag();
  AsnLen seqBytesDecoded = 0;
  AsnLen elmtLen1 = 0;
  tag1 = BDecTag (_b, seqBytesDecoded);

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, OID_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    name.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (name)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE))
    || (tag1 == MAKE_TAG_ID (UNIV, PRIM, OCTETSTRING_TAG_CODE))
    || (tag1 == MAKE_TAG_ID (UNIV, CONS, OCTETSTRING_TAG_CODE))
    || (tag1 == MAKE_TAG_ID (UNIV, PRIM, OID_TAG_CODE))
    || (tag1 == MAKE_TAG_ID (UNIV, PRIM, NULLTYPE_TAG_CODE))
    || (tag1 == MAKE_TAG_ID (APPL, PRIM, 0))
    || (tag1 == MAKE_TAG_ID (APPL, CONS, 0))
    || (tag1 == MAKE_TAG_ID (APPL, PRIM, 1))
    || (tag1 == MAKE_TAG_ID (APPL, PRIM, 2))
    || (tag1 == MAKE_TAG_ID (APPL, PRIM, 3))
    || (tag1 == MAKE_TAG_ID (APPL, PRIM, 4))
    || (tag1 == MAKE_TAG_ID (APPL, CONS, 4)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    value.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (value)", DECODE_ERROR);
  }

  bytesDecoded += seqBytesDecoded;
  if (elmtLen0 == INDEFINITE_LEN)
  {
    BDecEoc (_b, bytesDecoded);
    return;
  }
  else if (seqBytesDecoded != elmtLen0)
  {
    throw EXCEPT("Length discrepancy on sequence", DECODE_ERROR);
  }
  else
    return;
} // VarBind::BDecContent

AsnLen VarBind::BEnc (AsnBuf &_b) const
{
  AsnLen l=0;
  l = BEncContent (_b);
  l += BEncConsLen (_b, l);
  l += BEncTag1 (_b, UNIV, CONS, SEQ_TAG_CODE);
  return l;
}

void VarBind::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
  FUNC(" VarBind::BDec");
  AsnTag tag;
  AsnLen elmtLen1;

  if ((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (UNIV, CONS, SEQ_TAG_CODE))
  {
    throw InvalidTagException(typeName(), tag, STACK_ENTRY);
  }
  elmtLen1 = BDecLen (_b, bytesDecoded);
  BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

void VarBind::Print(std::ostream& os, unsigned short indent) const
{
	os << "{ -- SEQUENCE --" << std::endl;
++indent;

	Indent(os, indent);
	os << "name ";
	name.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "value ";
	value.Print(os, indent);

	os << std::endl;
	--indent;
	Indent(os, indent);
	os << "}\n";
} // end of VarBind::Print()

void VarBind::PrintXML (std::ostream &os, 
                   const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
     if (typeName() && strlen(typeName()))
     {
        os << " typeName=\"" << typeName() << "\"";
     }
  }
  else
  {
     os << "<NONE";
  }
  if (typeName() && strlen(typeName()))
  {
     if (typeName() && strlen(typeName()))
     {
        os << "<" << typeName();
     }
  }
 os << " type=\"SEQUENCE\">" << std::endl;
    name.PrintXML(os, "name");

    value.PrintXML(os, "value");

  if (lpszTitle)
  {
     os << "</" << lpszTitle << ">" << std::endl;
  }
  else
     if (typeName() && strlen(typeName()))
     {
        os << "</" << typeName() << ">" << std::endl;
     }
} // VarBind::PrintXML


void PDU::Init(void)
{
}


int PDU::checkConstraints(ConstraintFailList* pConstraintFails) const{
	request_id.checkConstraints(pConstraintFails);

	error_status.checkConstraints(pConstraintFails);

	error_index.checkConstraints(pConstraintFails);

	variable_bindings.checkConstraints(pConstraintFails);

	return 0;
}


void PDU::Clear()
{
}

PDU::PDU(const PDU &that)
{
   Init();
   *this = that;
}
AsnType *PDU::Clone() const
{
  return new PDU(*this);
}

PDU &PDU::operator = (const PDU &that)
{
  if (this != &that)
  {
    Clear();
    request_id = that.request_id;
    error_status = that.error_status;
    error_index = that.error_index;
    variable_bindings = that.variable_bindings;
  }

  return *this;
}

AsnLen
PDU::BEncContent (AsnBuf &_b) const
{
  AsnLen totalLen = 0;
  AsnLen l=0;

    l = variable_bindings.BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, UNIV, CONS, SEQ_TAG_CODE);
    totalLen += l;

    l = error_index.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, INTEGER_TAG_CODE);
    totalLen += l;

    l = error_status.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, INTEGER_TAG_CODE);
    totalLen += l;

    l = request_id.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, INTEGER_TAG_CODE);
    totalLen += l;

  return totalLen;
} // PDU::BEncContent


void PDU::BDecContent (const AsnBuf &_b, AsnTag /*tag0*/, AsnLen elmtLen0, AsnLen &bytesDecoded)
{
  FUNC(" PDU::BDecContent");
  Clear();
  AsnTag tag1 = AsnTag();
  AsnLen seqBytesDecoded = 0;
  AsnLen elmtLen1 = 0;
  tag1 = BDecTag (_b, seqBytesDecoded);

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    request_id.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (request-id)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    error_status.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (error-status)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    error_index.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (error-index)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, CONS, SEQ_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    variable_bindings.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (variable-bindings)", DECODE_ERROR);
  }

  bytesDecoded += seqBytesDecoded;
  if (elmtLen0 == INDEFINITE_LEN)
  {
    BDecEoc (_b, bytesDecoded);
    return;
  }
  else if (seqBytesDecoded != elmtLen0)
  {
    throw EXCEPT("Length discrepancy on sequence", DECODE_ERROR);
  }
  else
    return;
} // PDU::BDecContent

AsnLen PDU::BEnc (AsnBuf &_b) const
{
  AsnLen l=0;
  l = BEncContent (_b);
  l += BEncConsLen (_b, l);
  l += BEncTag1 (_b, UNIV, CONS, SEQ_TAG_CODE);
  return l;
}

void PDU::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
  FUNC(" PDU::BDec");
  AsnTag tag;
  AsnLen elmtLen1;

  if ((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (UNIV, CONS, SEQ_TAG_CODE))
  {
    throw InvalidTagException(typeName(), tag, STACK_ENTRY);
  }
  elmtLen1 = BDecLen (_b, bytesDecoded);
  BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

void PDU::Print(std::ostream& os, unsigned short indent) const
{
	os << "{ -- SEQUENCE --" << std::endl;
++indent;

	Indent(os, indent);
	os << "request-id ";
	request_id.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "error-status ";
	error_status.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "error-index ";
	error_index.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "variable-bindings ";
	variable_bindings.Print(os, indent);

	os << std::endl;
	--indent;
	Indent(os, indent);
	os << "}\n";
} // end of PDU::Print()

void PDU::PrintXML (std::ostream &os, 
                   const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
     if (typeName() && strlen(typeName()))
     {
        os << " typeName=\"" << typeName() << "\"";
     }
  }
  else
  {
     os << "<NONE";
  }
  if (typeName() && strlen(typeName()))
  {
     if (typeName() && strlen(typeName()))
     {
        os << "<" << typeName();
     }
  }
 os << " type=\"SEQUENCE\">" << std::endl;
    request_id.PrintXML(os, "request-id");

    error_status.PrintXML(os, "error-status");

    error_index.PrintXML(os, "error-index");

    variable_bindings.PrintXML(os, "variable-bindings");

  if (lpszTitle)
  {
     os << "</" << lpszTitle << ">" << std::endl;
  }
  else
     if (typeName() && strlen(typeName()))
     {
        os << "</" << typeName() << ">" << std::endl;
     }
} // PDU::PrintXML


void Trap_PDU::Init(void)
{
}


int Trap_PDU::checkConstraints(ConstraintFailList* pConstraintFails) const{
	enterprise.checkConstraints(pConstraintFails);

	agent_addr.checkConstraints(pConstraintFails);

	generic_trap.checkConstraints(pConstraintFails);

	specific_trap.checkConstraints(pConstraintFails);

	time_stamp.checkConstraints(pConstraintFails);

	variable_bindings.checkConstraints(pConstraintFails);

	return 0;
}


void Trap_PDU::Clear()
{
  agent_addr.Clear();
}

Trap_PDU::Trap_PDU(const Trap_PDU &that)
{
   Init();
   *this = that;
}
AsnType *Trap_PDU::Clone() const
{
  return new Trap_PDU(*this);
}

Trap_PDU &Trap_PDU::operator = (const Trap_PDU &that)
{
  if (this != &that)
  {
    Clear();
    enterprise = that.enterprise;
    agent_addr = that.agent_addr;
    generic_trap = that.generic_trap;
    specific_trap = that.specific_trap;
    time_stamp = that.time_stamp;
    variable_bindings = that.variable_bindings;
  }

  return *this;
}

AsnLen
Trap_PDU::BEncContent (AsnBuf &_b) const
{
  AsnLen totalLen = 0;
  AsnLen l=0;

    l = variable_bindings.BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, UNIV, CONS, SEQ_TAG_CODE);
    totalLen += l;

    l = time_stamp.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, APPL, PRIM, 3);
    totalLen += l;

    l = specific_trap.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, INTEGER_TAG_CODE);
    totalLen += l;

    l = generic_trap.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, INTEGER_TAG_CODE);
    totalLen += l;

    l = agent_addr.BEncContent (_b);
    totalLen += l;

    l = enterprise.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, OID_TAG_CODE);
    totalLen += l;

  return totalLen;
} // Trap_PDU::BEncContent


void Trap_PDU::BDecContent (const AsnBuf &_b, AsnTag /*tag0*/, AsnLen elmtLen0, AsnLen &bytesDecoded)
{
  FUNC(" Trap_PDU::BDecContent");
  Clear();
  AsnTag tag1 = AsnTag();
  AsnLen seqBytesDecoded = 0;
  AsnLen elmtLen1 = 0;
  tag1 = BDecTag (_b, seqBytesDecoded);

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, OID_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    enterprise.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (enterprise)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (APPL, PRIM, 0))
    || (tag1 == MAKE_TAG_ID (APPL, CONS, 0)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    agent_addr.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (agent-addr)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    generic_trap.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (generic-trap)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    specific_trap.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (specific-trap)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (APPL, PRIM, 3)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    time_stamp.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (time-stamp)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, CONS, SEQ_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    variable_bindings.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (variable-bindings)", DECODE_ERROR);
  }

  bytesDecoded += seqBytesDecoded;
  if (elmtLen0 == INDEFINITE_LEN)
  {
    BDecEoc (_b, bytesDecoded);
    return;
  }
  else if (seqBytesDecoded != elmtLen0)
  {
    throw EXCEPT("Length discrepancy on sequence", DECODE_ERROR);
  }
  else
    return;
} // Trap_PDU::BDecContent

AsnLen Trap_PDU::BEnc (AsnBuf &_b) const
{
  AsnLen l=0;
  l = BEncContent (_b);
  l += BEncConsLen (_b, l);
  l += BEncTag1 (_b, CNTX, CONS, 4);
  return l;
}

void Trap_PDU::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
  FUNC(" Trap_PDU::BDec");
  AsnTag tag;
  AsnLen elmtLen1;

  if ((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (CNTX, CONS, 4))
  {
    throw InvalidTagException(typeName(), tag, STACK_ENTRY);
  }
  elmtLen1 = BDecLen (_b, bytesDecoded);
  BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

void Trap_PDU::Print(std::ostream& os, unsigned short indent) const
{
	os << "{ -- SEQUENCE --" << std::endl;
++indent;

	Indent(os, indent);
	os << "enterprise ";
	enterprise.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "agent-addr ";
	agent_addr.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "generic-trap ";
	generic_trap.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "specific-trap ";
	specific_trap.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "time-stamp ";
	time_stamp.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "variable-bindings ";
	variable_bindings.Print(os, indent);

	os << std::endl;
	--indent;
	Indent(os, indent);
	os << "}\n";
} // end of Trap_PDU::Print()

void Trap_PDU::PrintXML (std::ostream &os, 
                   const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
     if (typeName() && strlen(typeName()))
     {
        os << " typeName=\"" << typeName() << "\"";
     }
  }
  else
  {
     os << "<NONE";
  }
  if (typeName() && strlen(typeName()))
  {
     if (typeName() && strlen(typeName()))
     {
        os << "<" << typeName();
     }
  }
 os << " type=\"SEQUENCE\">" << std::endl;
    enterprise.PrintXML(os, "enterprise");

    agent_addr.PrintXML(os, "agent-addr");

    generic_trap.PrintXML(os, "generic-trap");

    specific_trap.PrintXML(os, "specific-trap");

    time_stamp.PrintXML(os, "time-stamp");

    variable_bindings.PrintXML(os, "variable-bindings");

  if (lpszTitle)
  {
     os << "</" << lpszTitle << ">" << std::endl;
  }
  else
     if (typeName() && strlen(typeName()))
     {
        os << "</" << typeName() << ">" << std::endl;
     }
} // Trap_PDU::PrintXML


AsnType *GetRequest_PDU::Clone() const
{
  return new GetRequest_PDU(*this);
}

AsnLen GetRequest_PDU::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 0);
    return l;
}

void GetRequest_PDU::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("GetRequest_PDU::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (CNTX, CONS, 0)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

AsnType *GetNextRequest_PDU::Clone() const
{
  return new GetNextRequest_PDU(*this);
}

AsnLen GetNextRequest_PDU::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 1);
    return l;
}

void GetNextRequest_PDU::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("GetNextRequest_PDU::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (CNTX, CONS, 1)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

AsnType *GetResponse_PDU::Clone() const
{
  return new GetResponse_PDU(*this);
}

AsnLen GetResponse_PDU::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 2);
    return l;
}

void GetResponse_PDU::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("GetResponse_PDU::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (CNTX, CONS, 2)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

AsnType *SetRequest_PDU::Clone() const
{
  return new SetRequest_PDU(*this);
}

AsnLen SetRequest_PDU::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 3);
    return l;
}

void SetRequest_PDU::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    FUNC("SetRequest_PDU::BDec");
    AsnTag tag;
    AsnLen elmtLen1;

    if (((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (CNTX, CONS, 3)))
    {
        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
    }
    elmtLen1 = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

PDUs::PDUs(const PDUs &that)
{
   Init();
   *this = that;
}
void PDUs::Init(void)
{
   // initialize choice to no choiceId to first choice and set pointer to NULL
  choiceId = get_requestCid;
  get_request = NULL;
}


int PDUs::checkConstraints(ConstraintFailList* pConstraintFails) const
{
	if (get_request != NULL)
		get_request->checkConstraints(pConstraintFails);

	if (get_next_request != NULL)
		get_next_request->checkConstraints(pConstraintFails);

	if (get_response != NULL)
		get_response->checkConstraints(pConstraintFails);

	if (set_request != NULL)
		set_request->checkConstraints(pConstraintFails);

	if (trap != NULL)
		trap->checkConstraints(pConstraintFails);

	return 0;
}


void PDUs::Clear()
{
  switch (choiceId)
  {
    case get_requestCid:
      delete get_request;
      get_request = NULL;
      break;
    case get_next_requestCid:
      delete get_next_request;
      get_next_request = NULL;
      break;
    case get_responseCid:
      delete get_response;
      get_response = NULL;
      break;
    case set_requestCid:
      delete set_request;
      set_request = NULL;
      break;
    case trapCid:
      delete trap;
      trap = NULL;
      break;
  } // end of switch
} // end of Clear()

AsnType *PDUs::Clone() const
{
  return new PDUs(*this);
}

PDUs &PDUs::operator = (const PDUs &that)
{
  if (this != &that)
  {
    Clear();
    // Check first type in choice to determine if choice is empty
    if (that.get_request != NULL)
    {
       switch (choiceId = that.choiceId)
       {
         case get_requestCid:
           get_request = new GetRequest_PDU(*that.get_request);
           break;
         case get_next_requestCid:
           get_next_request = new GetNextRequest_PDU(*that.get_next_request);
           break;
         case get_responseCid:
           get_response = new GetResponse_PDU(*that.get_response);
           break;
         case set_requestCid:
           set_request = new SetRequest_PDU(*that.set_request);
           break;
         case trapCid:
           trap = new Trap_PDU(*that.trap);
           break;
       }// end of switch
     }// end of if
  }

  return *this;
}

AsnLen
PDUs::BEncContent (AsnBuf &_b) const
{
    FUNC("PDUs::BEncContent (AsnBuf &_b)");
  AsnLen l=0;
  switch (choiceId)
  {
    case get_requestCid:
      l = get_request->BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 0);
      break;

    case get_next_requestCid:
      l = get_next_request->BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 1);
      break;

    case get_responseCid:
      l = get_response->BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 2);
      break;

    case set_requestCid:
      l = set_request->BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 3);
      break;

    case trapCid:
      l = trap->BEncContent (_b);
    l += BEncConsLen (_b, l);

    l += BEncTag1 (_b, CNTX, CONS, 4);
      break;

      default:
         throw EXCEPT("Choice is empty", ENCODE_ERROR);
  } // end switch
  return l;
} // PDUs::BEncContent


void PDUs::BDecContent (const AsnBuf &_b, AsnTag tag, AsnLen elmtLen0, AsnLen &bytesDecoded /*, s env*/)
{
   FUNC("PDUs::BDecContent()");
   Clear();
  switch (tag)
  {
    case MAKE_TAG_ID (CNTX, CONS, 0):
      choiceId = get_requestCid;
        get_request = new GetRequest_PDU;
        get_request->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (CNTX, CONS, 1):
      choiceId = get_next_requestCid;
        get_next_request = new GetNextRequest_PDU;
        get_next_request->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (CNTX, CONS, 2):
      choiceId = get_responseCid;
        get_response = new GetResponse_PDU;
        get_response->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (CNTX, CONS, 3):
      choiceId = set_requestCid;
        set_request = new SetRequest_PDU;
        set_request->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    case MAKE_TAG_ID (CNTX, CONS, 4):
      choiceId = trapCid;
        trap = new Trap_PDU;
        trap->BDecContent (_b, tag, elmtLen0, bytesDecoded);
      break;

    default:
    {        throw InvalidTagException(typeName(), tag, STACK_ENTRY);
      break;
    }
  } // end switch
} // PDUs::BDecContent


AsnLen PDUs::BEnc (AsnBuf &_b) const
{
    AsnLen l=0;
    l = BEncContent (_b);
    return l;
}

void PDUs::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
    AsnLen elmtLen = 0;
    AsnTag tag;

    /*  CHOICEs are a special case - grab identifying tag */
    /*  this allows easier handling of nested CHOICEs */
    tag = BDecTag (_b, bytesDecoded);
    elmtLen = BDecLen (_b, bytesDecoded);
    BDecContent (_b, tag, elmtLen, bytesDecoded);
}

void PDUs::Print(std::ostream& os, unsigned short indent) const
{
	switch (choiceId)
	{
	case get_requestCid:
		os << "get-request ";
		if (get_request)
			get_request->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case get_next_requestCid:
		os << "get-next-request ";
		if (get_next_request)
			get_next_request->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case get_responseCid:
		os << "get-response ";
		if (get_response)
			get_response->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case set_requestCid:
		os << "set-request ";
		if (set_request)
			set_request->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	case trapCid:
		os << "trap ";
		if (trap)
			trap->Print(os, indent);
		else
			os << "<CHOICE value is missing>\n";
		break;

	} // end of switch
} // end of PDUs::Print()

void PDUs::PrintXML (std::ostream &os, const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
        os << " typeName=\"PDUs\" type=\"CHOICE\">";
  }
  else
        os << "<PDUs type=\"CHOICE\">";
  switch (choiceId)
  {
    case get_requestCid:
      if (get_request)
        get_request->PrintXML(os,"get-request");
      else
      {
        os << "<get-request -- void3 -- /get-request>" << std::endl;
      }
      break;

    case get_next_requestCid:
      if (get_next_request)
        get_next_request->PrintXML(os,"get-next-request");
      else
      {
        os << "<get-next-request -- void3 -- /get-next-request>" << std::endl;
      }
      break;

    case get_responseCid:
      if (get_response)
        get_response->PrintXML(os,"get-response");
      else
      {
        os << "<get-response -- void3 -- /get-response>" << std::endl;
      }
      break;

    case set_requestCid:
      if (set_request)
        set_request->PrintXML(os,"set-request");
      else
      {
        os << "<set-request -- void3 -- /set-request>" << std::endl;
      }
      break;

    case trapCid:
      if (trap)
        trap->PrintXML(os,"trap");
      else
      {
        os << "<trap -- void3 -- /trap>" << std::endl;
      }
      break;

  } // end of switch
  if (lpszTitle)
     os << "</" << lpszTitle << ">";
  else
        os << "</PDUs>";
} // PDUs::PrintXML

void Message::Init(void)
{
}


int Message::checkConstraints(ConstraintFailList* pConstraintFails) const{
	version.checkConstraints(pConstraintFails);

	community.checkConstraints(pConstraintFails);

	data.checkConstraints(pConstraintFails);

	return 0;
}


void Message::Clear()
{
  data.Clear();
}

Message::Message(const Message &that)
{
   Init();
   *this = that;
}
AsnType *Message::Clone() const
{
  return new Message(*this);
}

Message &Message::operator = (const Message &that)
{
  if (this != &that)
  {
    Clear();
    version = that.version;
    community = that.community;
    data = that.data;
  }

  return *this;
}

AsnLen
Message::BEncContent (AsnBuf &_b) const
{
  AsnLen totalLen = 0;
  AsnLen l=0;

    l = data.BEncContent (_b);
    totalLen += l;

    l = community.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, OCTETSTRING_TAG_CODE);
    totalLen += l;

    l = version.BEncContent (_b);
    l += BEncDefLen (_b, l);

    l += BEncTag1 (_b, UNIV, PRIM, INTEGER_TAG_CODE);
    totalLen += l;

  return totalLen;
} // Message::BEncContent


void Message::BDecContent (const AsnBuf &_b, AsnTag /*tag0*/, AsnLen elmtLen0, AsnLen &bytesDecoded)
{
  FUNC(" Message::BDecContent");
  Clear();
  AsnTag tag1 = AsnTag();
  AsnLen seqBytesDecoded = 0;
  AsnLen elmtLen1 = 0;
  tag1 = BDecTag (_b, seqBytesDecoded);

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, INTEGER_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    version.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (version)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (UNIV, PRIM, OCTETSTRING_TAG_CODE))
    || (tag1 == MAKE_TAG_ID (UNIV, CONS, OCTETSTRING_TAG_CODE)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    community.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
    tag1 = BDecTag (_b, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (community)", DECODE_ERROR);
  }

  if ((tag1 == MAKE_TAG_ID (CNTX, CONS, 0))
    || (tag1 == MAKE_TAG_ID (CNTX, CONS, 1))
    || (tag1 == MAKE_TAG_ID (CNTX, CONS, 2))
    || (tag1 == MAKE_TAG_ID (CNTX, CONS, 3))
    || (tag1 == MAKE_TAG_ID (CNTX, CONS, 4)))
  {
    elmtLen1 = BDecLen (_b, seqBytesDecoded);
    data.BDecContent (_b, tag1, elmtLen1, seqBytesDecoded);
  }
  else
  {
      throw EXCEPT("SEQUENCE is missing non-optional root elmt (data)", DECODE_ERROR);
  }

  bytesDecoded += seqBytesDecoded;
  if (elmtLen0 == INDEFINITE_LEN)
  {
    BDecEoc (_b, bytesDecoded);
    return;
  }
  else if (seqBytesDecoded != elmtLen0)
  {
    throw EXCEPT("Length discrepancy on sequence", DECODE_ERROR);
  }
  else
    return;
} // Message::BDecContent

AsnLen Message::BEnc (AsnBuf &_b) const
{
  AsnLen l=0;
  l = BEncContent (_b);
  l += BEncConsLen (_b, l);
  l += BEncTag1 (_b, UNIV, CONS, SEQ_TAG_CODE);
  return l;
}

void Message::BDec (const AsnBuf &_b, AsnLen &bytesDecoded)
{
  FUNC(" Message::BDec");
  AsnTag tag;
  AsnLen elmtLen1;

  if ((tag = BDecTag (_b, bytesDecoded)) != MAKE_TAG_ID (UNIV, CONS, SEQ_TAG_CODE))
  {
    throw InvalidTagException(typeName(), tag, STACK_ENTRY);
  }
  elmtLen1 = BDecLen (_b, bytesDecoded);
  BDecContent (_b, tag, elmtLen1, bytesDecoded);
}

void Message::Print(std::ostream& os, unsigned short indent) const
{
	os << "{ -- SEQUENCE --" << std::endl;
++indent;

	Indent(os, indent);
	os << "version ";
	version.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "community ";
	community.Print(os, indent);
	os << ',' << std::endl;

	Indent(os, indent);
	os << "data ";
	data.Print(os, indent);

	os << std::endl;
	--indent;
	Indent(os, indent);
	os << "}\n";
} // end of Message::Print()

void Message::PrintXML (std::ostream &os, 
                   const char *lpszTitle) const
{
  if (lpszTitle)
  {
     os << "<" << lpszTitle;
     if (typeName() && strlen(typeName()))
     {
        os << " typeName=\"" << typeName() << "\"";
     }
  }
  else
  {
     os << "<NONE";
  }
  if (typeName() && strlen(typeName()))
  {
     if (typeName() && strlen(typeName()))
     {
        os << "<" << typeName();
     }
  }
 os << " type=\"SEQUENCE\">" << std::endl;
    version.PrintXML(os, "version");

    community.PrintXML(os, "community");

    data.PrintXML(os, "data");

  if (lpszTitle)
  {
     os << "</" << lpszTitle << ">" << std::endl;
  }
  else
     if (typeName() && strlen(typeName()))
     {
        os << "</" << typeName() << ">" << std::endl;
     }
} // Message::PrintXML


#ifndef NO_NAMESPACE
} // namespace close
#endif
